Linux Audio

Check our new training course

Loading...
v6.9.4
  1# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
  2# Most of this file is copied from tools/lib/traceevent/Makefile
  3
  4RM ?= rm
  5srctree := $(realpath $(srctree))
  6
  7VERSION_SCRIPT := libbpf.map
  8LIBBPF_VERSION := $(shell \
  9	grep -oE '^LIBBPF_([0-9.]+)' $(VERSION_SCRIPT) | \
 10	sort -rV | head -n1 | cut -d'_' -f2)
 11LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$(LIBBPF_VERSION)))
 12LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$(LIBBPF_VERSION)))
 13
 14MAKEFLAGS += --no-print-directory
 15
 16# This will work when bpf is built in tools env. where srctree
 17# isn't set and when invoked from selftests build, where srctree
 18# is a ".". building_out_of_srctree is undefined for in srctree
 19# builds
 20ifndef building_out_of_srctree
 21srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 22srctree := $(patsubst %/,%,$(dir $(srctree)))
 23srctree := $(patsubst %/,%,$(dir $(srctree)))
 24#$(info Determined 'srctree' to be $(srctree))
 25endif
 26
 27INSTALL = install
 28
 29# Use DESTDIR for installing into a different root directory.
 30# This is useful for building a package. The program will be
 31# installed in this directory as if it was the root directory.
 32# Then the build tool can move it later.
 33DESTDIR ?=
 34DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 35
 36include $(srctree)/tools/scripts/Makefile.arch
 37
 38ifeq ($(LP64), 1)
 39  libdir_relative = lib64
 40else
 41  libdir_relative = lib
 42endif
 43
 44prefix ?= /usr/local
 45libdir = $(prefix)/$(libdir_relative)
 46man_dir = $(prefix)/share/man
 47man_dir_SQ = '$(subst ','\'',$(man_dir))'
 48
 49export man_dir man_dir_SQ INSTALL
 50export DESTDIR DESTDIR_SQ
 51
 52include $(srctree)/tools/scripts/Makefile.include
 53
 54# copy a bit from Linux kbuild
 55
 56ifeq ("$(origin V)", "command line")
 57  VERBOSE = $(V)
 58endif
 59ifndef VERBOSE
 60  VERBOSE = 0
 61endif
 62
 63INCLUDES = -I$(or $(OUTPUT),.) \
 64	   -I$(srctree)/tools/include -I$(srctree)/tools/include/uapi
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 65
 66export prefix libdir src obj
 67
 68# Shell quotes
 69libdir_SQ = $(subst ','\'',$(libdir))
 70libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 71
 72OBJ		= $@
 73N		=
 74
 75LIB_TARGET	= libbpf.a libbpf.so.$(LIBBPF_VERSION)
 76LIB_FILE	= libbpf.a libbpf.so*
 77PC_FILE		= libbpf.pc
 78
 79# Set compile option CFLAGS
 80ifdef EXTRA_CFLAGS
 81  CFLAGS := $(EXTRA_CFLAGS)
 82else
 83  CFLAGS := -g -O2
 
 
 
 
 
 
 
 
 84endif
 85
 86# Append required CFLAGS
 87override CFLAGS += -std=gnu89
 88override CFLAGS += $(EXTRA_WARNINGS) -Wno-switch-enum
 89override CFLAGS += -Werror -Wall
 
 90override CFLAGS += $(INCLUDES)
 91override CFLAGS += -fvisibility=hidden
 92override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 93override CFLAGS += $(CLANG_CROSS_FLAGS)
 94
 95# flags specific for shared library
 96SHLIB_FLAGS := -DSHARED -fPIC
 97
 98ifeq ($(VERBOSE),1)
 99  Q =
100else
101  Q = @
102endif
103
104# Disable command line variables (CFLAGS) override from top
105# level Makefile (perf), otherwise build Makefile will get
106# the same command line setup.
107MAKEOVERRIDES=
108
109all:
110
111export srctree OUTPUT CC LD CFLAGS V
112include $(srctree)/tools/build/Makefile.include
113
114SHARED_OBJDIR	:= $(OUTPUT)sharedobjs/
115STATIC_OBJDIR	:= $(OUTPUT)staticobjs/
116BPF_IN_SHARED	:= $(SHARED_OBJDIR)libbpf-in.o
117BPF_IN_STATIC	:= $(STATIC_OBJDIR)libbpf-in.o
118BPF_HELPER_DEFS	:= $(OUTPUT)bpf_helper_defs.h
119BPF_GENERATED	:= $(BPF_HELPER_DEFS)
120
121LIB_TARGET	:= $(addprefix $(OUTPUT),$(LIB_TARGET))
122LIB_FILE	:= $(addprefix $(OUTPUT),$(LIB_FILE))
123PC_FILE		:= $(addprefix $(OUTPUT),$(PC_FILE))
124
125TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
126
127GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
128			   cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
129			   sed 's/\[.*\]//' | \
130			   awk '/GLOBAL/ && /DEFAULT && !/UND|ABS/ {print $$NF}' | \
131			   sort -u | wc -l)
132VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OUTPUT)libbpf.so | \
133			      sed 's/\[.*\]//' | \
134			      awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
135			      grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
136
137CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
138
 
 
 
 
 
 
 
 
139all: fixdep
140	$(Q)$(MAKE) all_cmd
141
142all_cmd: $(CMD_TARGETS) check
143
144$(BPF_IN_SHARED): force $(BPF_GENERATED)
145	@(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
146	(diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
147	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
148	@(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
149	(diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
150	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
 
 
 
 
 
 
151	@(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
152	(diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
153	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
154	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
155
156$(BPF_IN_STATIC): force $(BPF_GENERATED)
157	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
158
159$(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
160	$(QUIET_GEN)$(srctree)/scripts/bpf_doc.py --header \
161		--file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
162
163$(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
164
165$(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED) $(VERSION_SCRIPT)
166	$(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS) \
167		--shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
168		-Wl,--version-script=$(VERSION_SCRIPT) $< -lelf -lz -o $@
169	@ln -sf $(@F) $(OUTPUT)libbpf.so
170	@ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
171
172$(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
173	$(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ $^
 
 
 
174
175$(OUTPUT)libbpf.pc:
176	$(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
177		-e "s|@LIBDIR@|$(libdir_SQ)|" \
178		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
179		< libbpf.pc.template > $@
180
181check: check_abi check_version
182
183check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT)
184	@if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then	 \
185		echo "Warning: Num of global symbols in $(BPF_IN_SHARED)"	 \
186		     "($(GLOBAL_SYM_COUNT)) does NOT match with num of"	 \
187		     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
188		     "Please make sure all LIBBPF_API symbols are"	 \
189		     "versioned in $(VERSION_SCRIPT)." >&2;		 \
190		readelf -s --wide $(BPF_IN_SHARED) |			 \
191		    cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |	 \
192		    sed 's/\[.*\]//' |					 \
193		    awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
194		    sort -u > $(OUTPUT)libbpf_global_syms.tmp;		 \
195		readelf --dyn-syms --wide $(OUTPUT)libbpf.so |		 \
196		    sed 's/\[.*\]//' |					 \
197		    awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}'|  \
198		    grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |		 \
199		    sort -u > $(OUTPUT)libbpf_versioned_syms.tmp; 	 \
200		diff -u $(OUTPUT)libbpf_global_syms.tmp			 \
201		     $(OUTPUT)libbpf_versioned_syms.tmp;		 \
202		rm $(OUTPUT)libbpf_global_syms.tmp			 \
203		   $(OUTPUT)libbpf_versioned_syms.tmp;			 \
204		exit 1;							 \
205	fi
206
207HDR_MAJ_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MAJOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
208HDR_MIN_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MINOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
209
210check_version: $(VERSION_SCRIPT) libbpf_version.h
211	@if [ "$(HDR_MAJ_VERSION)" != "$(LIBBPF_MAJOR_VERSION)" ]; then        \
212		echo "Error: libbpf major version mismatch detected: "	       \
213		     "'$(HDR_MAJ_VERSION)' != '$(LIBBPF_MAJOR_VERSION)'" >&2;  \
214		exit 1;							       \
215	fi
216	@if [ "$(HDR_MIN_VERSION)" != "$(LIBBPF_MINOR_VERSION)" ]; then	       \
217		echo "Error: libbpf minor version mismatch detected: "	       \
218		     "'$(HDR_MIN_VERSION)' != '$(LIBBPF_MINOR_VERSION)'" >&2;  \
219		exit 1;							       \
220	fi
221
222define do_install_mkdir
223	if [ ! -d '$(DESTDIR_SQ)$1' ]; then		\
224		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1';	\
225	fi
226endef
227
228define do_install
229	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
230		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
231	fi;						\
232	$(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR_SQ)$2'
233endef
234
235install_lib: all_cmd
236	$(call QUIET_INSTALL, $(LIB_TARGET)) \
237		$(call do_install_mkdir,$(libdir_SQ)); \
238		cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
239
240SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h	     \
241	    bpf_helpers.h bpf_tracing.h bpf_endian.h bpf_core_read.h	     \
242	    skel_internal.h libbpf_version.h usdt.bpf.h
243GEN_HDRS := $(BPF_GENERATED)
244
245INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf
246INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX)/, $(SRC_HDRS))
247INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX)/, $(notdir $(GEN_HDRS)))
248
249$(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h
250	$(call QUIET_INSTALL, $@) \
251		$(call do_install,$<,$(prefix)/include/bpf,644)
252
253$(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUTPUT)%.h
254	$(call QUIET_INSTALL, $@) \
255		$(call do_install,$<,$(prefix)/include/bpf,644)
256
257install_headers: $(BPF_GENERATED) $(INSTALL_SRC_HDRS) $(INSTALL_GEN_HDRS)
258	$(call QUIET_INSTALL, libbpf_headers)
259
260install_pkgconfig: $(PC_FILE)
261	$(call QUIET_INSTALL, $(PC_FILE)) \
262		$(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
263
264install: install_lib install_pkgconfig install_headers
 
 
 
 
 
 
265
266clean:
267	$(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS)		     \
268		*~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_GENERATED)		     \
269		$(SHARED_OBJDIR) $(STATIC_OBJDIR)			     \
270		$(addprefix $(OUTPUT),					     \
271			    *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
 
272
273PHONY += force cscope tags check check_abi check_version
274force:
275
276cscope:
277	ls *.c *.h > cscope.files
278	cscope -b -q -I $(srctree)/include -f cscope.out
279
280tags:
281	$(RM) -f TAGS tags
282	ls *.c *.h | xargs $(TAGS_PROG) -a
283
284# Declare the contents of the .PHONY variable as phony.  We keep that
285# information in a variable so we can use it in if_changed and friends.
286.PHONY: $(PHONY)
287
288# Delete partially updated (corrupted) files on error
289.DELETE_ON_ERROR:
290
291help:
292	@echo 'libbpf common targets:'
293	@echo '  HINT: use "V=1" to enable verbose build'
294	@echo '  all     - build libraries and pkgconfig'
295	@echo '  clean   - remove all generated files'
296	@echo '  check   - check ABI and version info'
297	@echo ''
298	@echo 'libbpf install targets:'
299	@echo '  HINT: use "prefix"(defaults to "/usr/local") or "DESTDIR" (defaults to "/")'
300	@echo '        to adjust target destination, e.g. "make prefix=/usr/local install"'
301	@echo '  install          - build and install all headers, libraries and pkgconfig'
302	@echo '  install_headers  - install only headers to include/bpf'
303	@echo ''
304	@echo 'libbpf make targets:'
305	@echo '  tags    - use ctags to make tag information for source code browsing'
306	@echo '  cscope  - use cscope to make interactive source code browsing database'
v5.4
  1# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
  2# Most of this file is copied from tools/lib/traceevent/Makefile
  3
 
 
 
 
  4LIBBPF_VERSION := $(shell \
  5	grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | \
  6	sort -rV | head -n1 | cut -d'_' -f2)
  7LIBBPF_MAJOR_VERSION := $(firstword $(subst ., ,$(LIBBPF_VERSION)))
 
  8
  9MAKEFLAGS += --no-print-directory
 10
 11# This will work when bpf is built in tools env. where srctree
 12# isn't set and when invoked from selftests build, where srctree
 13# is a ".". building_out_of_srctree is undefined for in srctree
 14# builds
 15ifndef building_out_of_srctree
 16srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 17srctree := $(patsubst %/,%,$(dir $(srctree)))
 18srctree := $(patsubst %/,%,$(dir $(srctree)))
 19#$(info Determined 'srctree' to be $(srctree))
 20endif
 21
 22INSTALL = install
 23
 24# Use DESTDIR for installing into a different root directory.
 25# This is useful for building a package. The program will be
 26# installed in this directory as if it was the root directory.
 27# Then the build tool can move it later.
 28DESTDIR ?=
 29DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 30
 31include $(srctree)/tools/scripts/Makefile.arch
 32
 33ifeq ($(LP64), 1)
 34  libdir_relative = lib64
 35else
 36  libdir_relative = lib
 37endif
 38
 39prefix ?= /usr/local
 40libdir = $(prefix)/$(libdir_relative)
 41man_dir = $(prefix)/share/man
 42man_dir_SQ = '$(subst ','\'',$(man_dir))'
 43
 44export man_dir man_dir_SQ INSTALL
 45export DESTDIR DESTDIR_SQ
 46
 47include $(srctree)/tools/scripts/Makefile.include
 48
 49# copy a bit from Linux kbuild
 50
 51ifeq ("$(origin V)", "command line")
 52  VERBOSE = $(V)
 53endif
 54ifndef VERBOSE
 55  VERBOSE = 0
 56endif
 57
 58FEATURE_USER = .libbpf
 59FEATURE_TESTS = libelf libelf-mmap bpf reallocarray cxx
 60FEATURE_DISPLAY = libelf bpf
 61
 62INCLUDES = -I. -I$(srctree)/tools/include -I$(srctree)/tools/arch/$(ARCH)/include/uapi -I$(srctree)/tools/include/uapi
 63FEATURE_CHECK_CFLAGS-bpf = $(INCLUDES)
 64
 65check_feat := 1
 66NON_CHECK_FEAT_TARGETS := clean TAGS tags cscope help
 67ifdef MAKECMDGOALS
 68ifeq ($(filter-out $(NON_CHECK_FEAT_TARGETS),$(MAKECMDGOALS)),)
 69  check_feat := 0
 70endif
 71endif
 72
 73ifeq ($(check_feat),1)
 74ifeq ($(FEATURES_DUMP),)
 75include $(srctree)/tools/build/Makefile.feature
 76else
 77include $(FEATURES_DUMP)
 78endif
 79endif
 80
 81export prefix libdir src obj
 82
 83# Shell quotes
 84libdir_SQ = $(subst ','\'',$(libdir))
 85libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 86
 87OBJ		= $@
 88N		=
 89
 90LIB_TARGET	= libbpf.a libbpf.so.$(LIBBPF_VERSION)
 91LIB_FILE	= libbpf.a libbpf.so*
 92PC_FILE		= libbpf.pc
 93
 94# Set compile option CFLAGS
 95ifdef EXTRA_CFLAGS
 96  CFLAGS := $(EXTRA_CFLAGS)
 97else
 98  CFLAGS := -g -Wall
 99endif
100
101ifeq ($(feature-libelf-mmap), 1)
102  override CFLAGS += -DHAVE_LIBELF_MMAP_SUPPORT
103endif
104
105ifeq ($(feature-reallocarray), 0)
106  override CFLAGS += -DCOMPAT_NEED_REALLOCARRAY
107endif
108
109# Append required CFLAGS
110override CFLAGS += $(EXTRA_WARNINGS)
 
111override CFLAGS += -Werror -Wall
112override CFLAGS += -fPIC
113override CFLAGS += $(INCLUDES)
114override CFLAGS += -fvisibility=hidden
115override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 
116
117# flags specific for shared library
118SHLIB_FLAGS := -DSHARED
119
120ifeq ($(VERBOSE),1)
121  Q =
122else
123  Q = @
124endif
125
126# Disable command line variables (CFLAGS) override from top
127# level Makefile (perf), otherwise build Makefile will get
128# the same command line setup.
129MAKEOVERRIDES=
130
131all:
132
133export srctree OUTPUT CC LD CFLAGS V
134include $(srctree)/tools/build/Makefile.include
135
136SHARED_OBJDIR	:= $(OUTPUT)sharedobjs/
137STATIC_OBJDIR	:= $(OUTPUT)staticobjs/
138BPF_IN_SHARED	:= $(SHARED_OBJDIR)libbpf-in.o
139BPF_IN_STATIC	:= $(STATIC_OBJDIR)libbpf-in.o
140VERSION_SCRIPT	:= libbpf.map
 
141
142LIB_TARGET	:= $(addprefix $(OUTPUT),$(LIB_TARGET))
143LIB_FILE	:= $(addprefix $(OUTPUT),$(LIB_FILE))
144PC_FILE		:= $(addprefix $(OUTPUT),$(PC_FILE))
145
 
 
146GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
147			   cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
148			   awk '/GLOBAL/ && /DEFAULT && !/UND/ {print $$8}' | \
 
149			   sort -u | wc -l)
150VERSIONED_SYM_COUNT = $(shell readelf -s --wide $(OUTPUT)libbpf.so | \
 
 
151			      grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
152
153CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
154
155CXX_TEST_TARGET = $(OUTPUT)test_libbpf
156
157ifeq ($(feature-cxx), 1)
158	CMD_TARGETS += $(CXX_TEST_TARGET)
159endif
160
161TARGETS = $(CMD_TARGETS)
162
163all: fixdep
164	$(Q)$(MAKE) all_cmd
165
166all_cmd: $(CMD_TARGETS) check
167
168$(BPF_IN_SHARED): force elfdep bpfdep
169	@(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
170	(diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
171	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
172	@(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
173	(diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
174	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
175	@(test -f ../../include/uapi/linux/netlink.h -a -f ../../../include/uapi/linux/netlink.h && ( \
176	(diff -B ../../include/uapi/linux/netlink.h ../../../include/uapi/linux/netlink.h >/dev/null) || \
177	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/netlink.h' differs from latest version at 'include/uapi/linux/netlink.h'" >&2 )) || true
178	@(test -f ../../include/uapi/linux/if_link.h -a -f ../../../include/uapi/linux/if_link.h && ( \
179	(diff -B ../../include/uapi/linux/if_link.h ../../../include/uapi/linux/if_link.h >/dev/null) || \
180	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_link.h' differs from latest version at 'include/uapi/linux/if_link.h'" >&2 )) || true
181	@(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
182	(diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
183	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
184	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
185
186$(BPF_IN_STATIC): force elfdep bpfdep
187	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
188
 
 
 
 
189$(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
190
191$(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED)
192	$(QUIET_LINK)$(CC) --shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
193				    -Wl,--version-script=$(VERSION_SCRIPT) $^ -lelf -o $@
 
194	@ln -sf $(@F) $(OUTPUT)libbpf.so
195	@ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
196
197$(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
198	$(QUIET_LINK)$(RM) $@; $(AR) rcs $@ $^
199
200$(OUTPUT)test_libbpf: test_libbpf.cpp $(OUTPUT)libbpf.a
201	$(QUIET_LINK)$(CXX) $(INCLUDES) $^ -lelf -o $@
202
203$(OUTPUT)libbpf.pc:
204	$(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
205		-e "s|@LIBDIR@|$(libdir_SQ)|" \
206		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
207		< libbpf.pc.template > $@
208
209check: check_abi
210
211check_abi: $(OUTPUT)libbpf.so
212	@if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then	 \
213		echo "Warning: Num of global symbols in $(BPF_IN_SHARED)"	 \
214		     "($(GLOBAL_SYM_COUNT)) does NOT match with num of"	 \
215		     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
216		     "Please make sure all LIBBPF_API symbols are"	 \
217		     "versioned in $(VERSION_SCRIPT)." >&2;		 \
218		readelf -s --wide $(OUTPUT)libbpf-in.o |		 \
219		    cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |	 \
220		    awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$8}'|   \
 
221		    sort -u > $(OUTPUT)libbpf_global_syms.tmp;		 \
222		readelf -s --wide $(OUTPUT)libbpf.so |			 \
 
 
223		    grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |		 \
224		    sort -u > $(OUTPUT)libbpf_versioned_syms.tmp; 	 \
225		diff -u $(OUTPUT)libbpf_global_syms.tmp			 \
226		     $(OUTPUT)libbpf_versioned_syms.tmp;		 \
227		rm $(OUTPUT)libbpf_global_syms.tmp			 \
228		   $(OUTPUT)libbpf_versioned_syms.tmp;			 \
229		exit 1;							 \
230	fi
231
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
232define do_install_mkdir
233	if [ ! -d '$(DESTDIR_SQ)$1' ]; then		\
234		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1';	\
235	fi
236endef
237
238define do_install
239	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
240		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
241	fi;						\
242	$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR_SQ)$2'
243endef
244
245install_lib: all_cmd
246	$(call QUIET_INSTALL, $(LIB_TARGET)) \
247		$(call do_install_mkdir,$(libdir_SQ)); \
248		cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
249
250install_headers:
251	$(call QUIET_INSTALL, headers) \
252		$(call do_install,bpf.h,$(prefix)/include/bpf,644); \
253		$(call do_install,libbpf.h,$(prefix)/include/bpf,644); \
254		$(call do_install,btf.h,$(prefix)/include/bpf,644); \
255		$(call do_install,libbpf_util.h,$(prefix)/include/bpf,644); \
256		$(call do_install,xsk.h,$(prefix)/include/bpf,644);
 
 
 
 
 
 
 
 
 
 
 
 
257
258install_pkgconfig: $(PC_FILE)
259	$(call QUIET_INSTALL, $(PC_FILE)) \
260		$(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
261
262install: install_lib install_pkgconfig
263
264### Cleaning rules
265
266config-clean:
267	$(call QUIET_CLEAN, config)
268	$(Q)$(MAKE) -C $(srctree)/tools/build/feature/ clean >/dev/null
269
270clean:
271	$(call QUIET_CLEAN, libbpf) $(RM) -rf $(TARGETS) $(CXX_TEST_TARGET) \
272		*.o *~ *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) .*.d .*.cmd \
273		*.pc LIBBPF-CFLAGS $(SHARED_OBJDIR) $(STATIC_OBJDIR)
274	$(call QUIET_CLEAN, core-gen) $(RM) $(OUTPUT)FEATURE-DUMP.libbpf
275
276
277
278PHONY += force elfdep bpfdep
279force:
280
281elfdep:
282	@if [ "$(feature-libelf)" != "1" ]; then echo "No libelf found"; exit 1 ; fi
283
284bpfdep:
285	@if [ "$(feature-bpf)" != "1" ]; then echo "BPF API too old"; exit 1 ; fi
 
 
286
287# Declare the contents of the .PHONY variable as phony.  We keep that
288# information in a variable so we can use it in if_changed and friends.
289.PHONY: $(PHONY)